import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
public class TriDiagMat extends Frame
{  public TriDiagMat()
   {  setSize(800,500);
      addWindowListener(new WindowAdapter()
      { public void windowClosing(WindowEvent e){System.exit(0);}
      });
   }
   public double [] MultMV(double [][] A,double [] B, int N1,int N2)
   {  int i,j,k;
      double [] C = new double[N1];
      for(i=0;i<N1;i++)
      {  C[i]=0.0;
         for(k=0;k<N2;k++) C[i] += A[i][k] * B[k];
      }
      return C;
   }
   public double [][] TriDiagToMat(double [][] A, int N)
   {  int i,j;
      double [][] X = new double[N][N];      
      for(i=0;i<N;i++) for(j=0;j<N; j++)X[i][j]=0;
      X[0][0] = A[0][1]; X[0][1] = A[0][2];
      for(i = 1; i < N - 1;i++){X[i][i-1]=A[i][0];X[i][i]=A[i][1];X[i][i+1]=A[i][2];}
      X[N - 1][N - 2] = A[N - 1][0]; X[N - 1][N - 1] = A[N - 1][1];
      return X;
   }
   public double [] TriDiagMatSimEq(double [][] A, double[] D, int N)
   {
      double []X  = new double[N];
      double []CC = new double[N];
      int i, j;
      double btemp = A[0][1]; X[0] = D[0] / btemp;
      for(j = 1; j < N; j++)
      {
         CC[j] = A[j - 1][2] / btemp;
         btemp = A[j][1] - A[j][0] * CC[j];
         X[j]  = (D[j] - A[j][0] * X[j - 1]) / btemp;
      }
      for(j = N - 2;j >= 0; j--) X[j] -= CC[j + 1] * X[j + 1];
      return X;
   }
   public void drawBra(Graphics g, int X, int Y, int H)
   {  g.drawLine( X, Y, X, Y + H);g.drawLine( X, Y, X + 2,Y);g.drawLine( X,Y + H, X + 2, Y + H);
   }
   public void drawKet(Graphics g, int X, int Y, int H)
   {  g.drawLine( X, Y, X, Y + H);g.drawLine( X, Y, X - 2,Y);g.drawLine( X,Y + H, X - 2, Y + H);
   }
   private double round(double D,int N)
   {  double DN=10*Math.pow(10.0,(double)(N-1));
      return Math.rint(D*DN)/DN;
   }
   public void DrawData(Graphics g, int Y, double [][] A, double []B, int N)
   {  int i, j;
      for(i=0;i<N;i++)
      {
         for(j=0;j<3; j++)
         {  g.drawString( "" + round(A[i][j],3), 50 + j * 50,Y + i * 20);
         }
         g.drawString( "" + round(B[i],3), 300, Y + i * 20);
      }
      drawBra(g, 40, Y - 10, 110); drawKet(g,190, Y - 10, 110);
      drawBra(g,290, Y - 10, 110); drawKet(g,340, Y - 10, 110);
   } 

   public void DrawMatVect(Graphics g, String ope1,String ope2, int Y,
                       double [][] A,double [] B,double [] C,int N1,int N2)
   {  int i, j;
      g.drawString( ope1,360,Y + 50);
      g.drawString( ope2,500,Y + 50);
      for(i=0;i<N1;i++)
      { for(j=0;j<N2; j++)g.drawString( "" + round(A[i][j],3), 50 + j*50,Y + i*20);
        g.drawString( "" + round(B[i],3),400, Y + i*20);
        g.drawString( "" + round(C[i],3),550, Y + i*20);
      }  
      drawBra(g, 40, Y - 10, 110); drawKet(g,340, Y - 10, 110);
      drawBra(g,390, Y - 10, 110); drawKet(g,450, Y - 10, 110);
      drawBra(g,540, Y - 10, 110); drawKet(g,590, Y - 10, 110);
   } 
   public void paint(Graphics g)
   {  int i,j;
      double [][] A={{0,2,1},{1,3,2},{2,4,1},{1,5,2},{2,6,1},{1,7,0}};
      double []   B={1,2,3,4,5,6};
      setTitle("OdΊp̘A");
      g.drawString( "f[^",20,50);
      DrawData(g, 80, A, B, 6);
      double []  X = TriDiagMatSimEq(A, B, 6);
      g.drawString( "mF",20,220);
      double [][] AA=TriDiagToMat(A, 6);
      double []C= MultMV(AA, X, 6, 6);
      DrawMatVect(g, "","", 240, AA, X, C, 6,6);
   } 
   public static void main(String[] args)
   {  Frame w = new TriDiagMat();
      w.setVisible(true);
   }
}
